import javax.swing.*;
import java.awt.*;

class LineChart extends Chart {
    int maxData=0;

    public LineChart(int[] data) {
	super(data);
	for (int i=0; i<data.length; i++) 
	    if (data[i]>maxData) 
		maxData=data[i];
    }

    public void draw(Graphics g) {
	float spacing  = width/(data.length-1f);

	int x1,y1, x2,y2;
	x1=0; y1=height - scale(data[0]);
	for (int i=1; i<data.length ; i++) {
	    x2=(int)(i*spacing);
	    y2=height - scale(data[i]);
	    g.drawLine(x1,y1,x2,y2);
	    x1=x2; y1=y2;
	}

	//draw a baseline to represent zero
	g.drawLine(0,height,width,height);
    }

    private int scale(int number) {
	return (int)(height*(float)number/maxData);
    }
}
